//paddle.cs

datablock AudioProfile(paddleHitSound)
{
	filename	 = "./paddle_hit.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(pingPongBallBounceSound)
{
	filename	 = "./ball_bounce.wav";
	description = AudioClose3d;
	preload = true;
};

datablock ParticleData(pingPongPaddleTrailParticle)
{
	dragCoefficient		= 8;
	gravityCoefficient	= 0;
	inheritedVelFactor	= 0;
	constantAcceleration = 0.0;
	lifetimeMS			  = 225;
	lifetimeVarianceMS	= 0;
	textureName			 = "base/data/particles/cloud";
	spinSpeed		= 0.0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 0.0;
	colors[0]	  = "0.9 0.9 0.9 0.3";
	colors[1]	  = "0.7 0.5 0.0 0.0";
	sizes[0]		= 0.25;
	sizes[1]		= 0.0;
};

datablock ParticleEmitterData(pingPongPaddleTrailEmitter)
{
	ejectionPeriodMS = 20;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0;
	ejectionOffset	= 0;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel  = 0;
	phiVariance		= 360;
	overrideAdvance = false;
	particles = "pingPongPaddleTrailParticle";
};

datablock ParticleData(pingPongPaddleExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.3;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]	  = "0.9 0.9 0.9 0.3";
	colors[1]	  = "0.7 0.5 0.0 0.0";
	sizes[0]      = 0.45;
	sizes[1]      = 0.0;
};

datablock ParticleEmitterData(pingPongPaddleExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "pingPongPaddleExplosionParticle";
};

datablock ExplosionData(pingPongPaddleExplosion)
{
	lifeTimeMS = 150;
	particleEmitter = pingPongPaddleExplosionEmitter;
	particleDensity = 5;
	particleRadius = 0.2;
	faceViewer	  = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
};

datablock ProjectileData(pingPongPaddleProjectile)
{
	projectileShapeName = "./ppball.dts";
	directDamage		  = 0;

	brickExplosionRadius = 0;
	brickExplosionImpact = false;
	brickExplosionForce  = 0;
	brickExplosionMaxVolume = 0;
	brickExplosionMaxVolumeFloating = 0;  

	impactImpulse		  = 0;
	verticalImpulse	  = 0;
	explosion			  = pingPongPaddleExplosion;
	particleEmitter	  = pingPongPaddleTrailEmitter;

	muzzleVelocity		= 12;
	velInheritFactor	 = 0;
	ballRadius          = 0.065;

	armingDelay			= 5000;
	lifetime				= 5000;
	fadeDelay			  = 3500;
	bounceElasticity	 = 0.75;
	bounceFriction		= 0.10;
	isBallistic			= true;
	gravityMod = 1;
	
	explodeOnDeath = true;
	
	uiName = "Ping-Pong Ball";
};

//item 
datablock ItemData(pingPongPaddleItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./paddle.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Paddle";
	iconName = "./icon_paddle";
	doColorShift = true;
	colorShiftColor = "0.85 0.00 0.00 1.00";

	image = pingPongPaddleImage;
	canDrop = true;
};

//weapon image
datablock ShapeBaseImageData(pingPongPaddleImage)
{
	shapeFile = "./paddle.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; 
	correctMuzzleVector = false;	
	doColorShift = true;
	colorShiftColor = pingPongPaddleItem.colorShiftColor;
	className = "WeaponImage";
	item = BowItem;
	ammo = " ";
	projectile = pingPongPaddleProjectile;
	projectileType = Projectile;	
	melee = false;
	armReady = true;
	minShotTime = 500;

	stateName[0]							= "Activate";
	stateTimeoutValue[0]				 = 0.15;
	stateTransitionOnTimeout[0]		 = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]							= "Ready";
	stateTransitionOnNoAmmo[1]	= "CheckState";
	stateTransitionOnTriggerDown[1]  = "CheckState";
	stateAllowImageChange[1]			= true;
	
	stateName[2]					= "CheckState";
	stateTransitionOnNoAmmo[2]	= "hitReady";
	stateTransitionOnAmmo[2]  = "serveReady";
	stateSequence[2]	= "paddlePrep";
	stateAllowImageChange[2]			= true;
	
	stateName[3]							= "serveReady";
	stateSequence[3]	= "paddleUnuse";
	stateTransitionOnTriggerDown[3]  = "Fire";
	stateAllowImageChange[3]			= true;
	
	stateName[4]							= "hitReady";
	stateTransitionOnTriggerDown[4]  = "return";
	stateAllowImageChange[4]			= true;
	
	stateName[5]                    = "Fire";
	stateTransitionOnTimeout[5]     = "hitReady";
	stateTimeoutValue[5]            = 0.14;
	stateFire[5]                    = true;
	stateAllowImageChange[5]        = false;
	stateSequence[5]                = "paddlePrep";
	stateScript[5]                  = "onFire";
	stateWaitForTimeout[5]			= true;
	stateSound[5]					= paddleHitSound;
	
	stateName[6]                    = "return";
	stateTransitionOnTimeout[6]     = "wait";
	stateTimeoutValue[6]            = 0.14;
	stateAllowImageChange[6]        = false;
	stateSequence[6]               = "paddleUse";
	stateScript[6]                  = "onPPReturn";
	stateWaitForTimeout[6]			= true;
	
	stateName[7] = "wait";
	stateTransitionOnTriggerUp[7] = "hitReady";
};

function pingPongPaddleProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	serverPlay3D(pingPongBallBounceSound,%obj.getTransform());
	
	Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
}

function pingPongPaddleImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
	{
		%obj.playThread(2, shiftTo); 
	}

	Parent::onFire(%this,%obj,%slot);	
}

function pingPongPaddleImage::onPPReturn(%this, %obj, %slot)
{
	%obj.playThread(2, plant); 
		
	%fvec = %obj.getForwardVector();
	%fX = getWord(%fvec,0);
	%fY = getWord(%fvec,1);
		
	%evec = %obj.getEyeVector();
	%eX = getWord(%evec,0);
	%eY = getWord(%evec,1);
	%eZ = getWord(%evec,2);
		
	%eXY = mSqrt(%eX*%eX+%eY*%eY);
		
	%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
		
	// initContainerRadiusSearch(%obj.getEyePoint(),getWord(%obj.getScale(),2)*1.75,$TypeMasks::ProjectileObjectType);
	initContainerRadiusSearch(%obj.getMuzzlePoint(0),getWord(%obj.getScale(),2)*1,$TypeMasks::ProjectileObjectType);
		
	while(isObject(firstWord(%searchObj = containerSearchNext())))
	{
		
		if(vectorLen(%searchObj.getVelocity()) == 0 || %searchObj.dataBlock.lifeTime <= 0)
			continue;
		
		%vel = vectorNormalize(%searchObj.getVelocity());
		if(vectorDot(%aimVec,%vel) > 0.30)
			continue;
		
		if(%searchObj.sourceObject == %obj && %searchObj.reflectTime > 0 && (getSimTime() - %searchObj.reflectTime) < 1000)
			continue;
			
		if(!%searchObj.dataBlock.uiName $= "Ping-Pong Ball")
			continue;

		%pos = %obj.getMuzzlePoint(0);
		//%vec = vectorScale(%obj.getMuzzleVector(0),vectorLen(%searchObj.getVelocity()));
		//%vel = vectorAdd(%vec,vectorScale(%obj.getVelocity(),%searchObj.dataBlock.velInheritFactor));
		
		%projectile = %searchObj.dataBlock;
		
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
			
		%p = new Projectile()
		{
			dataBlock = %searchObj.dataBlock;
			initialPosition = %pos;
			initialVelocity = %velocity;
			sourceObject = %obj;
			client = %obj.client;
			sourceSlot = 0;
			originPoint = %pos;
			reflectTime = getSimTime();
		};
			
		serverPlay3D(paddleHitSound,%searchObj.getTransform());
			
		MissionCleanup.add(%p);
						
		%searchObj.delete();
	}
}

//blue paddle

//datablock itemData(pingPongPaddleBlueItem : pingPongPaddleItem)
//{
//	uiName = "Paddle Blue";
//	colorShiftColor = "0.00 0.00 0.85 1.00";
//	image = pingPongPaddleBlueImage;
//};

//datablock shapeBaseImageData(pingPongPaddleBlueImage : pingPongPaddleImage)
//{
//	item = pingPongPaddleBlueItem;
//	colorShiftColor = pingPongPaddleBlueItem.colorShiftColor;
//};

//function pingPongPaddleBlueImage::onFire(%this,%obj,%slot)
//{
//	if(%obj.getDamagePercent() < 1.0)
//	{
//		%obj.playThread(2, shiftTo); 
//	}
//
//	Parent::onFire(%this,%obj,%slot);	
//}
